美文网首页
leetcode 每日两题之无重复字符的最长子串

leetcode 每日两题之无重复字符的最长子串

作者: 斌斌爱学习 | 来源:发表于2019-07-16 00:28 被阅读0次

    给定一个字符串,请你找出其中不含有重复字符的 最长子串 的长度。

    示例 1:

    输入: "abcabcbb"
    输出: 3
    解释: 因为无重复字符的最长子串是 "abc",所以其长度为 3。
    示例 2:

    输入: "bbbbb"
    输出: 1
    解释: 因为无重复字符的最长子串是 "b",所以其长度为 1。
    示例 3:

    输入: "pwwkew"
    输出: 3
    解释: 因为无重复字符的最长子串是 "wke",所以其长度为 3。
    请注意,你的答案必须是 子串 的长度,"pwke" 是一个子序列,不是子串。

    来源:力扣(LeetCode)
    链接:https://leetcode-cn.com/problems/longest-substring-without-repeating-characters

    首先能想到的一种方法是暴力破解法,即嵌套for循环来找到每一个不重复的子串,一一比较得出最后的值,代码如下:

    解法一:暴力三层for循环

    public int lengthOfLongestSubstring(String s) {
            int max=0;
            for(int i=0;i<s.length();i++){
                for(int j=i+1;j<=s.length();j++){
                    if(isUnique(s,i,j)){
                        max=Math.max(j-i,max);
                    }
                }
            }
            return max;
        }
        
        
        public boolean isUnique(String str,int start,int end){
            Set<Character> set=new HashSet<>();
            for(int i=start;i<end;i++){
                Character c=str.charAt(i);
                if(set.contains(c))return false;
                set.add(c);
            }
            return true;
        }
    

    这个算法肯定能求解,但是效率太低了,时间复杂度是O(n^3),非常吓人,提交上去leetcode直接提示超出时间了

    下面我们对此方法进行优化,我们边循环边将已经遍历过的元素存入一个set集合当中,一旦发现下一个元素已经存在于set中,则停止往下查找,拿到set的size跟当前的max比较,得到max,以此递归下去,这样就能更快的我们要的结果,代码如下:

    解法二:滑动窗口法

     public int lengthOfLongestSubstring(String s) {
            int max=0;
            int strLength=s.length();
            int i=0,j=0;
            Set<Character> set=new HashSet<>();
            while(i<strLength&&j<strLength){
                if(!set.contains(s.charAt(j))){
                    set.add(s.charAt(j++));
                    max=Math.max(max,j-i);
                }else{
                    set.remove(s.charAt(i++));
                }
            }
            return max;
        }
    

    上述算法其实还有可以改进的地方,set在滑动的时候只是一个一个的往后滑动,实际上多走了好几步,因为当1-4不重复,而第3个和第五个相同时,我们大可以直接从第四个开始重新滑动窗口,这样就大大减少了很多多余计算,具体代码如下:

    解法三:优化滑动窗口

    public int lengthOfLongestSubstring(String s) {
            int n = s.length(), ans = 0;
            Map<Character, Integer> map = new HashMap<>(); // current index of character
            // try to extend the range [i, j]
            for (int j = 0, i = 0; j < n; j++) {
                if (map.containsKey(s.charAt(j))) {
                    i = Math.max(map.get(s.charAt(j)), i);
                }
                ans = Math.max(ans, j - i +1);
                map.put(s.charAt(j), j +1);
            }
            return ans;
        }
    

    相关文章

      网友评论

          本文标题:leetcode 每日两题之无重复字符的最长子串

          本文链接:https://www.haomeiwen.com/subject/girakctx.html